#include <avr/io.h> 
#include <avr/interrupt.h>

#include "video.h"

short lines;
short temp;

void Video_Init()
{
	lines = -1;

	// Data direction settings	
	DDRD |= (1 << PD_BAS_SYNC);
	DDRC |= (1 << PC_PICTURE1) | (1 << PC_PICTURE2);

	//No prescaling 
	TCCR1B |= (1<<CS10);
  
  	//Setting up the timer for a full PAL line
//    OCR1A = TCNT1 + HSYNC_64_US;
    OCR1A = HSYNC_64_US;
    
    //Timer IRQ on
    TIMSK1 |= (1 << OCIE1A);

	// We always start with 
    VIDEO_SYNC_ON;
}

ISR (TIMER1_COMPA_vect)
{
	// Reset timer
	TCNT1 = 0;
	VIDEO_SYNC_ON;
	//PICTURE1_OFF;
	//PICTURE2_OFF;
	
	++lines;
	if(lines < VIDEO_BURST_ONE)
	{
		//while (TCNT1 < 64);
		//VIDEO_SYNC_ON;
		while (TCNT1 < 64+464);
		VIDEO_SYNC_OFF;
		while (TCNT1 < 64+464+32);
		VIDEO_SYNC_ON;
		//while (TCNT1 < 64+464+32+464);
		return;
	}

	if(lines < VIDEO_BURST_TWO)
	{
		VIDEO_SYNC_OFF;
		while (TCNT1 < 448);
		VIDEO_SYNC_ON;
		//while (TCNT1 < 448+64);
/*		if (lines == VIDEO_BURST_TWO - 1)
		{
			VIDEO_SYNC_OFF;
			while (TCNT1 < 448+64+64);
			VIDEO_SYNC_ON;
			//while (TCNT1 < 448+64+64+448);
		}
		else
		{
			VIDEO_SYNC_OFF;
			while (TCNT1 < 448+64+448);
			VIDEO_SYNC_ON;
			//while (TCNT1 < 448+64+448+64);
		} */
		return;
	}
	
	if(lines < VIDEO_BURST_THREE)
	{
		while (TCNT1 < 64+464);
		VIDEO_SYNC_OFF;
		while (TCNT1 < 64+464+32);
		VIDEO_SYNC_ON;
		//while (TCNT1 < 4+29+2+29);
		return;
	}
//	OCR1A = HSYNC_64_US;
	
//	VIDEO_SYNC_ON;
//	while (TCNT1 < 2);
//	VIDEO_SYNC_OFF;
	while (TCNT1 < 64);
	VIDEO_SYNC_OFF;
	while (TCNT1 < 64+64);
	VIDEO_SYNC_ON;

	while (TCNT1 < 64+64+20);

	PICTURE2_ON;
	PICTURE2_OFF;

	//while (TCNT1 < (72*10)+64);

	if(lines > 312) lines = -1;
	return;


	
}
